unit Figura;

interface

type
  TFigura = Class
    private
      FCor       : string;
    protected
      function  GetCor   : string;
      procedure SetCor (Value : string);
    public
      procedure Desenhe; virtual; abstract;
      property  Cor : string read GetCor write SetCor;
  End;

  TQuadrado = Class (TFigura)
    private
      FX : real;
    protected
      function  GetX : real;
      procedure SetX (Value : real);
    public
      procedure Desenhe ; override;
      property X : real read  GetX write SetX;
  End;

  TRetangulo = Class (TQuadrado)
    private
      FY : real;
    protected
      function  GetY : real;
      procedure SetY (Value : real);
    public
      procedure Desenhe; override;
      property Y : real read GetY write  SetY;
  End;

  TCirculo = Class (TFigura)
    private
      FRaio : real;
    protected
      function  GetRaio : real;
      procedure SetRaio (Value : Real);
    public
      procedure Desenhe ;override;
      property Raio : real read GetRaio write SetRaio;
  End;

implementation

uses dialogs, SysUtils;

{************TFigura************}

function  TFigura.GetCor   : string;
Begin
  Result := Self.FCor;
End;

procedure TFigura.SetCor (Value : string);
Begin
  Self.FCor := Value;
End;

{************TQuadrado************}

procedure TQuadrado.Desenhe;
Begin
  showMessage('Quadrado' + FloatToStr(Self.X));
End;

function  TQuadrado.GetX : real;
Begin
  Result := Self.FX;
End;

procedure TQuadrado.SetX (Value : real);
Begin
  Self.FX := Value;
End;

{************TRetangulo************}
procedure TRetangulo.Desenhe;
Begin
  showMessage('Retangulo' + FloatToStr(Self.X) + FloatToStr(Self.X));
End;

function  TRetangulo.GetY : real;
Begin
  Result := Self.FY;
End;

procedure TRetangulo.SetY (Value : real);
Begin
  Self.FY := Value;
End;

{**********TCirculo*********}

procedure TCirculo.Desenhe;
Begin
  showMessage('Circulo' + FloatToStr(Self.Raio));
End;

function  TCirculo.GetRaio : real;
Begin
  Result := Self.FRaio;
End;

procedure TCirculo.SetRaio (Value : Real);
Begin
  Self.FRaio := Value;
End;

end.
