unit Universidade;

interface

type

  TEndereco = Class
    private
      FRua, FBairro, FNumero  : String;
    protected
      function  GetRua    : string;
      function  GetBairro : string;
      function  GetNumero : string;
      procedure SetRua    (Value : string);
      procedure SetBairro (Value : string);
      procedure SetNumero (Value : string);
    public
      property  Rua    : string read GetRua    write SetRua;
      property  Bairro : string read GetBairro write SetBairro;
      property  Numero : string read GetNumero write SetNumero;
  End;

  TPessoa  = Class
    private
      FMatricula : string;
      FNome      : string;
    protected
      function    GetMatricula : string;
      function    GetNome      : string;
      procedure   SetMatricula (Value : string);
      procedure   SetNome      (Value : string);
    public
      Endereco  : TEndereco;
      constructor Create;
      destructor  Destroy; override;
      property Matricula : string read GetMatricula write SetMatricula;
      property Nome      : string read GetNome      write SetNome;
  End;

  TProfessor = Class(TPessoa)
    private
      FDepartamento : string;
      FAulasMes     : byte;
    protected
      function  GetDepartamento : string;
      function  GetAulasMes     : byte;
      procedure SetDepartamento (Value : string);
      procedure SetAulasMes     (Value : byte);
    public
      property Departamento : String read GetDepartamento write SetDepartamento;
      property AulasMes     : byte   read GetAulasMes     write SetAulasMes;
  End;
{
  TAluno = Class(TPessoa)
    private
      FCurso : string;
      FMGP   : real;
    protected
      function  GetCurso : string;
      function  GetMGP   : real;
      procedure SetCurso (Value : string);
      procedure SetMGP   (Value : byte);
    public
      property Curso : string read  GetCurso write SetCurso;
      property MGP   : string read  GetMGP   write SetMGP;
  End;

  TFuncionario = Class(TPessoa)
    private
      FSetor     : string;
      FSalario   : real;
    protected
      function  GetSetor        : string;
      function  GetSalario      : real;
      procedure SetSetor   (Value : string);
      procedure SetSalario (Value : byte);
    public
      property Setor   : string read  GetSetor   write SetSetor;
      property Salario : real   read  GetSalario write SetSalario;

  End;
}
implementation

{********************** TEndereco******************}

function    TEndereco.GetRua    : string;
Begin
  Result := Self.FRua;
End;

function    TEndereco.GetBairro : string;
Begin
  Result := Self.FBairro;
End;

function    TEndereco.GetNumero : string;
Begin
  Result := Self.FNumero;
End;

procedure   TEndereco.SetRua    (Value : string);
Begin
  Self.FRua := Value;
End;

procedure   TEndereco.SetBairro (Value : string);
Begin
  Self.FBairro := Value;
End;

procedure   TEndereco.SetNumero (Value : string);
Begin
  Self.FNumero := Value;
End;

{********************** TPessoa******************}

constructor TPessoa.Create;
Begin
  inherited Create;
  Self.Endereco := TEndereco.Create;
End;

destructor TPessoa.Destroy;
Begin
  Self.Endereco.Free;
  inherited Destroy;
End;

function    TPessoa.GetMatricula : string;
Begin
  Result := Self.FMatricula;
End;

function    TPessoa.GetNome      : string;
Begin
  Result := Self.FNome;
End;

procedure   TPessoa.SetMatricula (Value : string);
Begin
  Self.FMatricula := Value;
End;

procedure   TPessoa.SetNome      (Value : string);
Begin
  Self.FNome := Value;
End;

{********************** TProfessor******************}

function TProfessor.GetDepartamento : string;
Begin
  Result := Self.FDepartamento;
End;

function TProfessor.GetAulasMes : byte;
Begin
  Result := Self.FAulasMes;
End;

procedure Tprofessor.SetDepartamento (Value : string);
Begin
  Self.FDepartamento := Value;
End;

procedure Tprofessor.SetAulasMes (Value : byte);
Begin
  Self.FAulasMes := Value;
End;

end.
