unit Vetor;

interface

const
  Tam = 100;
type
  Vetor_T = array[1..Tam] of integer;

  TVetorInteiro = class
    private
      FDados   : Vetor_T;
      FTamanho : integer;
    protected
      function  GetDados (Posicao : integer) : integer;
      procedure SetDados (Posicao ,Value : integer);
      function  GetTamanho : integer;
      procedure SetTamanho (Value : integer);
    public
      property Tamanho : integer read GetTamanho write SetTamanho ;
      property Dados[Posicao : integer]  : integer
               read GetDados write SetDados; default;
      Procedure Insere( Value : integer);
      procedure Inverte;

  End;

implementation

{ TVetorInteiro}
function TVetorInteiro.GetTamanho : integer;
Begin
  Result := Self.FTamanho;
End;

procedure TVetorInteiro.SetTamanho (Value : integer);
Begin
  Self.FTamanho := Value;
End;

function TVetorInteiro.GetDados ( Posicao : integer) : integer;
Begin
  Result := Self.FDados[Posicao];
End;

procedure TVetorInteiro.SetDados (Posicao , Value : integer);
Begin
  Self.FDados[Posicao] := Value;
End;

procedure TVetorInteiro.Insere( Value : integer);
Begin
  with Self do
    Tamanho := Tamanho + 1;
    try
      Dados[Tamanho] := Value
    except
      Tamanho := Tamanho - 1;
  end;
End;

procedure TVetorInteiro.Inverte;
Var
  i, f : byte;
  aux : integer;
Begin
  i := 1;
  f := Self.Tamanho;
  while i < f do
  Begin
    aux     := Self[i];
    Self[i] := Self[f];
    Self[f] := aux;
    inc(i);
    inc(f,-1);
  End;
End;
end.
